config/routes.rb
Rails.application.routes.draw do

  
  resources :projects do
    resources :tickets do
      member do
        put :change
      end
      resources :timelogs
      resources :checkboxes do
        member do 
          patch :complete
        end 
      end
      resources :comments
    end
  end
  resources :lists do 
    resources :tasks do
      member do 
        put :change
        put :complete
      end
    end
  end 
  
  get 'pages/home'
  get 'about' => 'pages#about'
  get 'peoples' => 'pages#peoples'

  root 'projects#index'
  devise_for :users, :controllers => { registrations: 'registrations' }

  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/checkbox.rb
class Checkbox < ApplicationRecord
  belongs_to :ticket
end

app/models/comment.rb
class Comment < ApplicationRecord
  belongs_to :ticket
end

app/models/list.rb
class List < ApplicationRecord
	has_many :tasks
	belongs_to :user

	accepts_nested_attributes_for :tasks
	validates :user_id, presence: true

end

app/models/project.rb
class Project < ApplicationRecord
	has_many :tickets, dependent: :destroy

  accepts_nested_attributes_for :tickets

end

app/models/task.rb
class Task < ApplicationRecord
	belongs_to :list
	validates :content, presence: true

	auto_html_for :content do 
		html_escape
		image
		youtube(:width => "100%", :height => 250, :autoplay => false)
		link :target => "_blank", :rel => "nofollow"
		simple_format
	end
end

app/models/ticket.rb
class Ticket < ApplicationRecord
  belongs_to :project
  has_many :timelogs, dependent: :destroy
  has_many :comments, dependent: :destroy
  has_many :checkboxes, dependent: :destroy
  
  accepts_nested_attributes_for :timelogs
  accepts_nested_attributes_for :comments
  accepts_nested_attributes_for :checkboxes
  def previous
  	Ticket.where(["id < ? and project_id =?", id, project_id]).last
  end

  def next
  	Ticket.where(["id > ? and project_id = ?", id, project_id]).first
  end

  def placement
    Ticket.where(["project_id = ?", project_id]).order('id ASC').index(self)
  end

end

app/models/timelog.rb
class Timelog < ApplicationRecord
  belongs_to :ticket
end

app/models/user.rb
class User < ApplicationRecord
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable and :omniauthable
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :trackable, :validatable
  #has_many :tasks, dependent: :destroy
  has_many :lists, dependent: :destroy
end

app/controllers/lists_controller.rb
class ListsController < ApplicationController
  before_action :set_list, only: [:show, :edit, :update, :destroy]
  helper_method :last_update
  # GET /lists
  # GET /lists.json
  def index
    @doing ||= []
    @lists.each do |l|
      l.tasks.where(state: "doing").each do |d|
        @doing << d
      end 
    end

  end

  # GET /lists/1
  # GET /lists/1.json
  def show
    @list = @list = List.find(params[:id])
    @todo = @list.tasks.where(state: "to_do")
    @doing = @list.tasks.where(state: "doing")
    @done = @list.tasks.where(state: "done")

  end

  # GET /lists/new
  def new
    @list = List.new
    @list.tasks.build
  end

  # GET /lists/1/edit
  def edit
  end

  # POST /lists
  # POST /lists.json
  def create
    @list = List.new(list_params)
    @list.user_id = current_user.id if current_user
    respond_to do |format|
      if @list.save
        format.html { redirect_to @list, falsh: 'List was successfully created.' }
        format.json { render :show, status: :created, location: @list }
      else
        format.html { render :new }
        format.json { render json: @list.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /lists/1
  # PATCH/PUT /lists/1.json
  def update
    respond_to do |format|
      if @list.update(list_params)
        format.html { redirect_to @list, notice: 'List was successfully updated.' }
        format.json { render :show, status: :ok, location: @list }
      else
        format.html { render :edit }
        format.json { render json: @list.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /lists/1
  # DELETE /lists/1.json
  def destroy
    @list.destroy
    respond_to do |format|
      format.html { redirect_to lists_url, notice: 'List was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_list
      @list = List.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def list_params
      params.require(:list).permit(:name, :description, :id)
    end


end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/checkboxes_helper.rb
module CheckboxesHelper
end

app/helpers/comments_helper.rb
module CommentsHelper
end

app/helpers/lists_helper.rb
module ListsHelper

end

app/helpers/pages_helper.rb
module PagesHelper
end

app/helpers/projects_helper.rb
module ProjectsHelper
end

app/helpers/tasks_helper.rb
module TasksHelper

end

app/helpers/ticket_helper.rb
module TicketHelper
end

app/helpers/tickets_helper.rb
module TicketsHelper
end

app/helpers/timelogs_helper.rb
module TimelogsHelper
end

app/views/layouts/_header.html.erb
<nav class="navbar navbar-toggleable-md navbar-light bg-faded mb-3">
  <button class="navbar-toggler navbar-toggler-right" type="button" data-toggle="collapse" data-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="Toggle navigation">
    <span class="navbar-toggler-icon"></span>
  </button>

  <div class="container-fluid">
    <%= link_to "<i class='fa fa-gg' aria-hidden='true'></i> PlayGround".html_safe, pages_home_path, class: "navbar-brand"  if not current_user %>
    <%= link_to "<i class='fa fa-gg' aria-hidden='true'></i> PlayGround".html_safe, root_path, class: "navbar-brand"  if current_user %>
  </div>
  <div class="collapse navbar-collapse" id="navbarSupportedContent">
    <ul class="navbar-nav mr-auto">
    <% if current_user %>
      <li class="nav-item active">
      <%= link_to "Projects", projects_path, class: "nav-link" %>

      </li>
      <li class="nav-item dropdown">
              <a class="nav-link dropdown-toggle" href="#" id="dropdown05" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">TO-DO Lists</a>
              <div class="dropdown-menu" aria-labelledby="dropdown05">
              <%= link_to "All List", lists_path, class: "dropdown-item text-primary"%>
              <% @lists.each do |list| %>
                <%= link_to list.name, list, class: "dropdown-item" %>
              <% end %>

              </div>
      </li>

      <li class="nav-item active">
        <%= link_to "Peoples", peoples_path, class: "nav-link" %></li>
    </ul>
      <ul class="nav navbar-nav  navbar-right">     
      <li class="nav-item">
        <%= link_to (current_user.name + " " +current_user.last_name), edit_user_registration_path, class: "nav-link"%>
      </li>
      <li class="nav-item">
        <%= link_to "Log Out", destroy_user_session_path, method: :delete, class: "nav-link"%>
      </li>
    <% else %>
    </ul>    
    
    <ul class="navbar-nav  navbar-right pull-right">
      <li class="nav-item">
        <%= link_to "About", about_path, class: "nav-link"%>
      </li>
      <li class="nav-item">
        <%= link_to "Sign up", new_user_registration_path, class: "nav-link" %>
      </li>
      <li class="nav-text">
        <span class="navbar-text">|</span>      
      </li>
      <li class="nav-item">
        <%= link_to "Log in", new_user_session_path, class: "nav-link" %>
      </li>
    <% end %>
    </ul>
  </div>
</nav>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>PlayGround</title>
    <%= csrf_meta_tags %>

    <%= stylesheet_link_tag    'application', media: 'all', 'data-turbolinks-track': 'reload' %>
    <%= javascript_include_tag 'application', 'data-turbolinks-track': 'reload' %>
  </head>

  <body>
  <div role="navigation">
  <%= render "layouts/header" %>
  </div>
  <div class="container">
    <%= yield %>
  </div>
  </body>
</html>

app/views/pages/about.html.erb
<h1>About Us </h1>
<p> Our vision is to help people with theirs projects </p>

<button class="btn btn-primary" type="submit">Button</button>
<input class="btn btn-primary" type="button" value="Input">
<input class="btn btn-primary" type="submit" value="Submit">
<input class="btn btn-primary" type="reset" value="Reset">

app/views/pages/home.html.erb
<div class="jumbotron">
      <div class="container">
        <h1 class="display-3"> <i class="fa fa-gg" aria-hidden="true"></i> PlayGround</h1>
        <p>This is a template for a simple marketing or informational website. It includes a large callout called a jumbotron and three supporting pieces of content. Use it as a starting point to create something more unique.</p>
        <p> <%= link_to "Sign Up!", new_user_registration_path, class: "btn btn-primary btn-lg" %></p>
      </div>
    </div>

app/views/pages/peoples.html.erb
<p id="notice"><%= notice %></p>
<div class="container-fluid">
<div class="row">
	<nav class="breadcrumb">
	  <%= link_to "Home", root_path, class: "breadcrumb-item"%>
	  <%= link_to "Peoples", peoples_path, class: "breadcrumb-item"%>
	  <span class="breadcrumb-item active">All</span>
	</nav>
  </div>
	<div class="row">
		<table id="sorttable" class="table table-bordered table-striped tableserter">
		  <thead>
        <tr>
          <th>ID</th>
          <th>Name</th>
          <th>Email</th>
          <th>Phone</th>
          <th>IM</th>
          <th>Last Activity</th>
          <th>Open Issues</th>
        </tr>
      </thead>
      <tbody>
        
        <% @peoples.each do |people| %>
        <tr>
          <td><%= people.id %></td>
          <td><%= [people.name, people.last_name].join(" ")%> &nbsp;           
              <%if current_user == people %>
                <%= link_to "<i class='fa fa-pencil'></i>".html_safe, edit_user_registration_path %>
                &nbsp;
                <%= link_to "<i class='fa fa-times'></i>".html_safe, cancel_user_registration_path, data: { confirm: "Are you sure?" }, method: :delete %>
              <%end %>    
          </td>
          <td><%= people.email %></td>
          <td><%= people.phone %></td>
          <td><%= people.im %></td>
          <td><%= time_ago_in_words(people.last_sign_in_at) %></td>
          <td><%= Ticket.where(user_id: people.id).count %></td>
        </tr>
        <% end %>
      </tbody>
		</table>
	</div>
</div>